diff -ruN vdr-1.7.37/ci.c vdr-1.7.38/ci.c
--- vdr-1.7.37/ci.c	2012-10-07 13:11:18.000000000 +0200
+++ vdr-1.7.38/ci.c	2013-02-17 14:17:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 2.10 2012/10/07 11:11:18 kls Exp $
+ * $Id: ci.c 2.12 2013/02/17 13:17:28 kls Exp $
  */
 
 #include "ci.h"
@@ -35,7 +35,7 @@
 
 static const uint8_t *GetLength(const uint8_t *Data, int &Length)
 ///< Gets the length field from the beginning of Data.
-///< \return Returns a pointer to the first byte after the length and
+///< Returns a pointer to the first byte after the length and
 ///< stores the length value in Length.
 {
   Length = *Data++;
@@ -50,7 +50,7 @@
 
 static uint8_t *SetLength(uint8_t *Data, int Length)
 ///< Sets the length field at the beginning of Data.
-///< \return Returns a pointer to the first byte after the length.
+///< Returns a pointer to the first byte after the length.
 {
   uint8_t *p = Data;
   if (Length < 128)
@@ -70,7 +70,7 @@
 
 static char *CopyString(int Length, const uint8_t *Data)
 ///< Copies the string at Data.
-///< \return Returns a pointer to a newly allocated string.
+///< Returns a pointer to a newly allocated string.
 {
   // Some CAMs send funny characters at the beginning of strings.
   // Let's just skip them:
@@ -88,7 +88,7 @@
 
 static char *GetString(int &Length, const uint8_t **Data)
 ///< Gets the string at Data.
-///< \return Returns a pointer to a newly allocated string, or NULL in case of error.
+///< Returns a pointer to a newly allocated string, or NULL in case of error.
 ///< Upon return Length and Data represent the remaining data after the string has been skipped.
 {
   if (Length > 0 && Data && *Data) {
@@ -371,7 +371,7 @@
 
 int cCiSession::GetTag(int &Length, const uint8_t **Data)
 ///< Gets the tag at Data.
-///< \return Returns the actual tag, or AOT_NONE in case of error.
+///< Returns the actual tag, or AOT_NONE in case of error.
 ///< Upon return Length and Data represent the remaining data after the tag has been skipped.
 {
   if (Length >= 3 && Data && *Data) {
@@ -959,7 +959,7 @@
 
 char *cCiMMI::GetText(int &Length, const uint8_t **Data)
 ///< Gets the text at Data.
-///< \return Returns a pointer to a newly allocated string, or NULL in case of error.
+///< Returns a pointer to a newly allocated string, or NULL in case of error.
 ///< Upon return Length and Data represent the remaining data after the text has been skipped.
 {
   int Tag = GetTag(Length, Data);
@@ -1936,7 +1936,7 @@
      for (const int *Dpid = Channel->Dpids(); *Dpid; Dpid++)
          CaPmt.AddPid(*Dpid, STREAM_TYPE_PRIVATE);
      for (const int *Spid = Channel->Spids(); *Spid; Spid++)
-         CaPmt.AddPid(*Spid, STREAM_TYPE_PRIVATE); 
+         CaPmt.AddPid(*Spid, STREAM_TYPE_PRIVATE);
      cas->SendPMT(&CaPmt);
      cTimeMs Timeout(QUERY_REPLY_TIMEOUT);
      do {
diff -ruN vdr-1.7.37/config.c vdr-1.7.38/config.c
--- vdr-1.7.37/config.c	2013-02-05 12:16:08.000000000 +0100
+++ vdr-1.7.38/config.c	2013-02-14 16:14:37.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.34 2013/02/05 11:16:08 kls Exp $
+ * $Id: config.c 2.35 2013/02/14 15:14:37 kls Exp $
  */
 
 #include "config.h"
@@ -383,7 +383,7 @@
   MenuScrollWrap = 0;
   MenuKeyCloses = 0;
   MarkInstantRecord = 1;
-  strcpy(NameInstantRecord, "TITLE EPISODE");
+  strcpy(NameInstantRecord, TIMERMACRO_TITLE " " TIMERMACRO_EPISODE);
   InstantRecordTime = DEFINSTRECTIME;
   LnbSLOF    = 11700;
   LnbFrequLo =  9750;
diff -ruN vdr-1.7.37/config.h vdr-1.7.38/config.h
--- vdr-1.7.37/config.h	2013-02-05 12:19:20.000000000 +0100
+++ vdr-1.7.38/config.h	2013-02-14 16:13:59.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.64 2013/02/05 11:19:20 kls Exp $
+ * $Id: config.h 2.67 2013/02/14 15:13:59 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.37"
-#define VDRVERSNUM   10737  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.38"
+#define VDRVERSNUM   10738  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.37"
-#define APIVERSNUM   10737  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.38"
+#define APIVERSNUM   10738  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -44,6 +44,9 @@
 #define MAXLIFETIME       99
 #define DEFINSTRECTIME    180 // default instant recording time (minutes)
 
+#define TIMERMACRO_TITLE    "TITLE"
+#define TIMERMACRO_EPISODE  "EPISODE"
+
 #define MINOSDWIDTH   480
 #define MAXOSDWIDTH  1920
 #define MINOSDHEIGHT  324
diff -ruN vdr-1.7.37/cutter.c vdr-1.7.38/cutter.c
--- vdr-1.7.37/cutter.c	2013-01-23 11:39:27.000000000 +0100
+++ vdr-1.7.38/cutter.c	2013-02-17 15:11:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 2.23 2013/01/23 10:39:27 kls Exp $
+ * $Id: cutter.c 2.24 2013/02/17 14:11:03 kls Exp $
  */
 
 #include "cutter.h"
@@ -104,7 +104,7 @@
      buffers[Pid]->Flush(Data, Length, MaxLength);
 }
 
-// --- cMpeg2Fixer --------------------------------------------------------
+// --- cMpeg2Fixer -----------------------------------------------------------
 
 class cMpeg2Fixer : private cTsPayload {
 private:
diff -ruN vdr-1.7.37/device.c vdr-1.7.38/device.c
--- vdr-1.7.37/device.c	2013-02-01 13:00:09.000000000 +0100
+++ vdr-1.7.38/device.c	2013-02-16 15:39:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.71 2013/02/01 12:00:09 kls Exp $
+ * $Id: device.c 2.73 2013/02/16 14:39:30 kls Exp $
  */
 
 #include "device.h"
@@ -845,12 +845,12 @@
   return false;
 }
 
-bool cDevice::HasLock(int TimeoutMs)
+bool cDevice::HasLock(int TimeoutMs) const
 {
   return true;
 }
 
-bool cDevice::HasProgramme(void)
+bool cDevice::HasProgramme(void) const
 {
   return Replaying() || pidHandles[ptAudio].pid || pidHandles[ptVideo].pid;
 }
@@ -1537,7 +1537,7 @@
 int cDevice::Priority(void) const
 {
   int priority = IDLEPRIORITY;
-  if (IsPrimaryDevice() && !Replaying() && ActualDevice() == PrimaryDevice())
+  if (IsPrimaryDevice() && !Replaying() && HasProgramme())
      priority = TRANSFERPRIORITY; // we use the same value here, no matter whether it's actual Transfer Mode or real live viewing
   cMutexLock MutexLock(&mutexReceiver);
   for (int i = 0; i < MAXRECEIVERS; i++) {
diff -ruN vdr-1.7.37/device.h vdr-1.7.38/device.h
--- vdr-1.7.37/device.h	2013-02-01 12:54:08.000000000 +0100
+++ vdr-1.7.38/device.h	2013-02-16 16:20:01.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.45 2013/02/01 11:54:08 kls Exp $
+ * $Id: device.h 2.47 2013/02/16 15:20:01 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -116,7 +116,7 @@
          ///< Waits until all devices have become ready, or the given Timeout
          ///< (seconds) has expired. While waiting, the Ready() function of each
          ///< device is called in turn, until they all return true.
-         ///< \return True if all devices have become ready within the given
+         ///< Returns true if all devices have become ready within the given
          ///< timeout.
   static void SetUseDevice(int n);
          ///< Sets the 'useDevice' flag of the given device.
@@ -127,8 +127,8 @@
          ///< this instance of VDR.
   static bool SetPrimaryDevice(int n);
          ///< Sets the primary device to 'n'.
-         ///< \param n must be in the range 1...numDevices.
-         ///< \return true if this was possible.
+         ///< n must be in the range 1...numDevices.
+         ///< Returns true if this was possible.
   static cDevice *PrimaryDevice(void) { return primaryDevice; }
          ///< Returns the primary device.
   static cDevice *ActualDevice(void);
@@ -136,8 +136,8 @@
          ///< primary device otherwise.
   static cDevice *GetDevice(int Index);
          ///< Gets the device with the given Index.
-         ///< \param Index must be in the range 0..numDevices-1.
-         ///< \return A pointer to the device, or NULL if the Index was invalid.
+         ///< Index must be in the range 0..numDevices-1.
+         ///< Returns a pointer to the device, or NULL if the Index was invalid.
   static cDevice *GetDevice(const cChannel *Channel, int Priority, bool LiveView, bool Query = false);
          ///< Returns a device that is able to receive the given Channel at the
          ///< given Priority, with the least impact on active recordings and
@@ -328,13 +328,13 @@
          ///< after the device has been successfully tuned to the requested transponder.
          ///< Seconds will be silently limited to MAXOCCUPIEDTIMEOUT. Values less than
          ///< 0 will be silently ignored.
-  virtual bool HasLock(int TimeoutMs = 0);
+  virtual bool HasLock(int TimeoutMs = 0) const;
          ///< Returns true if the device has a lock on the requested transponder.
          ///< Default is true, a specific device implementation may return false
          ///< to indicate that it is not ready yet.
          ///< If TimeoutMs is not zero, waits for the given number of milliseconds
          ///< before returning false.
-  virtual bool HasProgramme(void);
+  virtual bool HasProgramme(void) const;
          ///< Returns true if the device is currently showing any programme to
          ///< the user, either through replaying or live.
 
@@ -432,19 +432,19 @@
 public:
   virtual uchar *GrabImage(int &Size, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
          ///< Grabs the currently visible screen image.
-         ///< \param Size The size of the returned data block.
-         ///< \param Jpeg If true will write a JPEG file. Otherwise a PNM file will be written.
-         ///< \param Quality The compression factor for JPEG. 1 will create a very blocky
-         ///<        and small image, 70..80 will yield reasonable quality images while keeping the
-         ///<        image file size around 50 KB for a full frame. The default will create a big
-         ///<        but very high quality image.
-         ///< \param SizeX The number of horizontal pixels in the frame (default is the current screen width).
-         ///< \param SizeY The number of vertical pixels in the frame (default is the current screen height).
-         ///< \return A pointer to the grabbed image data, or NULL in case of an error.
+         ///< Size is the size of the returned data block.
+         ///< If Jpeg is true it will write a JPEG file. Otherwise a PNM file will be written.
+         ///< Quality is the compression factor for JPEG. 1 will create a very blocky
+         ///< and small image, 70..80 will yield reasonable quality images while keeping the
+         ///< image file size around 50 KB for a full frame. The default will create a big
+         ///< but very high quality image.
+         ///< SizeX is the number of horizontal pixels in the frame (default is the current screen width).
+         ///< SizeY is the number of vertical pixels in the frame (default is the current screen height).
+         ///< Returns a pointer to the grabbed image data, or NULL in case of an error.
          ///< The caller takes ownership of the returned memory and must free() it once it isn't needed any more.
   bool GrabImageFile(const char *FileName, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
          ///< Calls GrabImage() and stores the resulting image in a file with the given name.
-         ///< \return True if all went well.
+         ///< Returns true if all went well.
          ///< The caller is responsible for making sure that the given file name
          ///< doesn't lead to overwriting any important other file.
 
@@ -509,7 +509,7 @@
        ///< Index tells which track of the given basic type is meant.
        ///< If Id is 0 any existing id will be left untouched and only the
        ///< given Language and Description will be set.
-       ///< \return Returns true if the track was set correctly, false otherwise.
+       ///< Returns true if the track was set correctly, false otherwise.
   const tTrackId *GetTrack(eTrackType Type);
        ///< Returns a pointer to the given track id, or NULL if Type is not
        ///< less than ttMaxTrackTypes.
@@ -525,14 +525,14 @@
   eTrackType GetCurrentAudioTrack(void) const { return currentAudioTrack; }
   bool SetCurrentAudioTrack(eTrackType Type);
        ///< Sets the current audio track to the given Type.
-       ///< \return Returns true if Type is a valid audio track, false otherwise.
+       ///< Returns true if Type is a valid audio track, false otherwise.
   eTrackType GetCurrentSubtitleTrack(void) const { return currentSubtitleTrack; }
   bool SetCurrentSubtitleTrack(eTrackType Type, bool Manual = false);
        ///< Sets the current subtitle track to the given Type.
        ///< IF Manual is true, no automatic preferred subtitle language selection
        ///< will be done for the rest of the current replay session, or until
        ///< the channel is changed.
-       ///< \return Returns true if Type is a valid subtitle track, false otherwise.
+       ///< Returns true if Type is a valid subtitle track, false otherwise.
   void EnsureAudioTrack(bool Force = false);
        ///< Makes sure an audio track is selected that is actually available.
        ///< If Force is true, the language and Dolby Digital settings will
@@ -593,13 +593,13 @@
        ///< Returns true if this device can currently start a replay session.
   virtual bool SetPlayMode(ePlayMode PlayMode);
        ///< Sets the device into the given play mode.
-       ///< \return true if the operation was successful.
+       ///< Returns true if the operation was successful.
   virtual int PlayVideo(const uchar *Data, int Length);
        ///< Plays the given data block as video.
        ///< Data points to exactly one complete PES packet of the given Length.
        ///< PlayVideo() shall process the packet either as a whole (returning
        ///< Length) or not at all (returning 0 or -1 and setting 'errno' accordingly).
-       ///< \return Returns the number of bytes actually taken from Data, or -1
+       ///< Returns the number of bytes actually taken from Data, or -1
        ///< in case of an error.
   virtual int PlayAudio(const uchar *Data, int Length, uchar Id);
        ///< Plays the given data block as audio.
@@ -607,14 +607,14 @@
        ///< Id indicates the type of audio data this packet holds.
        ///< PlayAudio() shall process the packet either as a whole (returning
        ///< Length) or not at all (returning 0 or -1 and setting 'errno' accordingly).
-       ///< \return Returns the number of bytes actually taken from Data, or -1
+       ///< Returns the number of bytes actually taken from Data, or -1
        ///< in case of an error.
   virtual int PlaySubtitle(const uchar *Data, int Length);
        ///< Plays the given data block as a subtitle.
        ///< Data points to exactly one complete PES packet of the given Length.
        ///< PlaySubtitle() shall process the packet either as a whole (returning
        ///< Length) or not at all (returning 0 or -1 and setting 'errno' accordingly).
-       ///< \return Returns the number of bytes actually taken from Data, or -1
+       ///< Returns the number of bytes actually taken from Data, or -1
        ///< in case of an error.
   virtual int PlayPesPacket(const uchar *Data, int Length, bool VideoOnly = false);
        ///< Plays the single PES packet in Data with the given Length.
@@ -658,7 +658,7 @@
        ///< Only the lower 32 bit of this value are actually used, since some
        ///< devices can't handle the msb correctly.
   virtual bool IsPlayingVideo(void) const { return isPlayingVideo; }
-       ///< \return Returns true if the currently attached player has delivered
+       ///< Returns true if the currently attached player has delivered
        ///< any video packets.
   virtual cRect CanScaleVideo(const cRect &Rect, int Alignment = taCenter) { return cRect::Null; }
        ///< Asks the output device whether it can scale the currently shown video in
diff -ruN vdr-1.7.37/dvbdevice.c vdr-1.7.38/dvbdevice.c
--- vdr-1.7.37/dvbdevice.c	2012-12-30 14:08:41.000000000 +0100
+++ vdr-1.7.38/dvbdevice.c	2013-02-17 14:17:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.77 2012/12/30 13:08:41 kls Exp $
+ * $Id: dvbdevice.c 2.80 2013/02/17 13:17:33 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -583,15 +583,13 @@
      while (1) {
            if (ioctl(fd_frontend, FE_READ_SNR, &Snr) != -1)
               break;
-           if (errno == EOPNOTSUPP) {
+           if (errno != EINTR) {
               Snr = 0xFFFF;
 #ifdef DEBUG_SIGNALQUALITY
               HasSnr = false;
 #endif
               break;
               }
-           if (errno != EINTR)
-              return -1;
            }
 #ifdef DEBUG_SIGNALQUALITY
      bool HasBer = true;
@@ -600,15 +598,13 @@
      while (1) {
            if (ioctl(fd_frontend, FE_READ_BER, &Ber) != -1)
               break;
-           if (errno == EOPNOTSUPP) {
+           if (errno != EINTR) {
               Ber = 0;
 #ifdef DEBUG_SIGNALQUALITY
               HasBer = false;
 #endif
               break;
               }
-           if (errno != EINTR)
-              return -1;
            }
 #ifdef DEBUG_SIGNALQUALITY
      bool HasUnc = true;
@@ -617,15 +613,13 @@
      while (1) {
            if (ioctl(fd_frontend, FE_READ_UNCORRECTED_BLOCKS, &Unc) != -1)
               break;
-           if (errno == EOPNOTSUPP) {
+           if (errno != EINTR) {
               Unc = 0;
 #ifdef DEBUG_SIGNALQUALITY
               HasUnc = false;
 #endif
               break;
               }
-           if (errno != EINTR)
-              return -1;
            }
      uint16_t MaxSnr = 0xFFFF; // Let's assume the default is using the entire range.
      // Use the subsystemId to identify individual devices in case they need
@@ -665,7 +659,7 @@
      }
   static cMutex Mutex;
   if (Diseqc->IsScr())
-     Mutex.Lock(); 
+     Mutex.Lock();
   struct dvb_diseqc_master_cmd cmd;
   const char *CurrentAction = NULL;
   for (;;) {
@@ -687,7 +681,7 @@
   if (scr)
      ResetToneAndVoltage(); // makes sure we don't block the bus!
   if (Diseqc->IsScr())
-     Mutex.Unlock(); 
+     Mutex.Unlock();
 }
 
 void cDvbTuner::ResetToneAndVoltage(void)
@@ -1541,7 +1535,7 @@
   return true;
 }
 
-bool cDvbDevice::HasLock(int TimeoutMs)
+bool cDvbDevice::HasLock(int TimeoutMs) const
 {
   return dvbTuner ? dvbTuner->Locked(TimeoutMs) : false;
 }
diff -ruN vdr-1.7.37/dvbdevice.h vdr-1.7.38/dvbdevice.h
--- vdr-1.7.37/dvbdevice.h	2012-03-31 13:13:31.000000000 +0200
+++ vdr-1.7.38/dvbdevice.h	2013-02-16 16:20:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.26 2012/03/31 11:13:31 kls Exp $
+ * $Id: dvbdevice.h 2.28 2013/02/16 15:20:17 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -119,7 +119,7 @@
   static bool Initialize(void);
          ///< Initializes the DVB devices.
          ///< Must be called before accessing any DVB functions.
-         ///< \return True if any devices are available.
+         ///< Returns true if any devices are available.
 protected:
   int adapter, frontend;
 private:
@@ -192,7 +192,7 @@
 protected:
   virtual bool SetChannelDevice(const cChannel *Channel, bool LiveView);
 public:
-  virtual bool HasLock(int TimeoutMs = 0);
+  virtual bool HasLock(int TimeoutMs = 0) const;
 
 // PID handle facilities
 
diff -ruN vdr-1.7.37/dvbplayer.c vdr-1.7.38/dvbplayer.c
--- vdr-1.7.37/dvbplayer.c	2013-01-27 15:03:16.000000000 +0100
+++ vdr-1.7.38/dvbplayer.c	2013-02-12 11:50:10.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 2.29 2013/01/27 14:03:16 kls Exp $
+ * $Id: dvbplayer.c 2.30 2013/02/12 10:50:10 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -576,7 +576,7 @@
           if (eof || SwitchToPlayFrame) {
              bool SwitchToPlay = false;
              uint32_t Stc = DeviceGetSTC();
-             if (Stc != LastStc)
+             if (Stc != LastStc || playMode == pmPause)
                 StuckAtEof = 0;
              else if (!StuckAtEof)
                 StuckAtEof = time(NULL);
diff -ruN vdr-1.7.37/dvbsubtitle.c vdr-1.7.38/dvbsubtitle.c
--- vdr-1.7.37/dvbsubtitle.c	2012-05-08 10:17:17.000000000 +0200
+++ vdr-1.7.38/dvbsubtitle.c	2013-02-17 14:17:38.000000000 +0100
@@ -7,7 +7,7 @@
  * Original author: Marco Schluessler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.32 2012/05/08 08:17:17 kls Exp $
+ * $Id: dvbsubtitle.c 2.33 2013/02/17 13:17:38 kls Exp $
  */
 
 
@@ -1283,7 +1283,7 @@
         }
   cDvbSubtitleBitmaps *Bitmaps = new cDvbSubtitleBitmaps(Page->Pts(), Page->Timeout(), Areas, NumAreas, osdFactorX, osdFactorY);
   bitmaps->Add(Bitmaps);
-  for (int i = 0; i < NumAreas; i++) { 
+  for (int i = 0; i < NumAreas; i++) {
       cSubtitleRegion *sr = Page->regions.Get(i);
       cSubtitleClut *clut = Page->GetClutById(sr->ClutId());
       if (!clut)
diff -ruN vdr-1.7.37/epg.c vdr-1.7.38/epg.c
--- vdr-1.7.37/epg.c	2012-10-04 14:21:24.000000000 +0200
+++ vdr-1.7.38/epg.c	2013-02-17 15:12:07.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.22 2012/10/04 12:21:24 kls Exp $
+ * $Id: epg.c 2.23 2013/02/17 14:12:07 kls Exp $
  */
 
 #include "epg.h"
@@ -1135,7 +1135,7 @@
   return false;
 }
 
-// --- cEpgDataWriter ---------------------------------------------------------
+// --- cEpgDataWriter --------------------------------------------------------
 
 class cEpgDataWriter : public cThread {
 private:
diff -ruN vdr-1.7.37/font.h vdr-1.7.38/font.h
--- vdr-1.7.37/font.h	2011-12-04 14:38:17.000000000 +0100
+++ vdr-1.7.38/font.h	2013-02-17 14:17:42.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.h 2.6 2011/12/04 13:38:17 kls Exp $
+ * $Id: font.h 2.7 2013/02/17 13:17:42 kls Exp $
  */
 
 #ifndef __FONT_H
@@ -43,7 +43,7 @@
           ///< Returns the font name.
   virtual int Size(void) const { return Height(); }
           ///< Returns the original size as requested when the font was created.
-          ///< This may be different than the actual height. 
+          ///< This may be different than the actual height.
   virtual int Width(uint c) const = 0;
           ///< Returns the width of the given character in pixel.
   virtual int Width(const char *s) const = 0;
diff -ruN vdr-1.7.37/lirc.c vdr-1.7.38/lirc.c
--- vdr-1.7.37/lirc.c	2013-02-03 12:23:18.000000000 +0100
+++ vdr-1.7.38/lirc.c	2013-02-11 16:25:42.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * LIRC support added by Carsten Koch <Carsten.Koch@icem.de>  2000-06-16.
  *
- * $Id: lirc.c 2.4 2013/02/03 11:23:18 kls Exp $
+ * $Id: lirc.c 2.5 2013/02/11 15:25:42 kls Exp $
  */
 
 #include "lirc.h"
@@ -114,9 +114,10 @@
               repeat = true;
               timeout = Delta * 10 / 9;
               }
-           if (pressed)
+           if (pressed) {
               LastTime.Set();
               Put(KeyName, repeat);
+              }
            }
         else if (pressed && repeat) { // the last one was a repeat, so let's generate a release
            Put(LastKeyName, false, true);
diff -ruN vdr-1.7.37/menu.c vdr-1.7.38/menu.c
--- vdr-1.7.37/menu.c	2013-02-02 15:00:39.000000000 +0100
+++ vdr-1.7.38/menu.c	2013-02-17 14:17:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.76 2013/02/02 14:00:39 kls Exp $
+ * $Id: menu.c 2.79 2013/02/17 13:17:49 kls Exp $
  */
 
 #include "menu.h"
@@ -2306,8 +2306,10 @@
             if (CurrentRecording && strcmp(CurrentRecording, recording->FileName()) == 0)
                SetCurrent(LastItem);
             }
-         if (LastDir)
+         if (LastDir) {
             LastDir->IncrementCounter(recording->IsNew());
+            LastItem = LastDir;
+            }
          }
       }
   if (Refresh)
@@ -2809,7 +2811,7 @@
   standardComplianceTexts[1] = "ANSI/SCTE";
 
   SetSection(tr("DVB"));
-  SetHelp(NULL, tr("Button$Audio"), tr("Button$Subtitles"), NULL); 
+  SetHelp(NULL, tr("Button$Audio"), tr("Button$Subtitles"), NULL);
   Setup();
 }
 
@@ -2863,7 +2865,7 @@
        case kYellow: cRemote::Put(kSubtitles, true);
                      state = osEnd;
                      break;
-       default: { 
+       default: {
             bool DoSetup = data.VideoFormat != newVideoFormat;
             DoSetup |= data.DisplaySubtitles != newDisplaySubtitles;
             if (numAudioLanguages != oldnumAudioLanguages) {
@@ -4763,9 +4765,8 @@
 {
   int Current, Total;
   if (GetIndex(Current, Total, true)) {
-     cMark *m = marks.Get(Current);
      lastCurrent = -1; // triggers redisplay
-     if (m)
+     if (cMark *m = marks.Get(Current))
         marks.Del(m);
      else {
         marks.Add(Current);
@@ -4784,8 +4785,7 @@
   int Current, Total;
   if (GetIndex(Current, Total)) {
      if (marks.Count()) {
-        cMark *m = Forward ? marks.GetNext(Current) : marks.GetPrev(Current);
-        if (m) {
+        if (cMark *m = Forward ? marks.GetNext(Current) : marks.GetPrev(Current)) {
            Goto(m->Position(), true);
            displayFrames = true;
            return;
@@ -4801,8 +4801,7 @@
 {
   int Current, Total;
   if (GetIndex(Current, Total)) {
-     cMark *m = marks.Get(Current);
-     if (m) {
+     if (cMark *m = marks.Get(Current)) {
         displayFrames = true;
         int p = SkipFrames(Forward ? 1 : -1);
         cMark *m2;
@@ -4878,7 +4877,7 @@
 {
   if (!Active())
      return osEnd;
-  if (Key == kNone)
+  if (Key == kNone && !marksModified)
      marks.Update();
   if (visible) {
      if (timeoutShow && time(NULL) > timeoutShow) {
@@ -4962,7 +4961,7 @@
                            else
                               Show();
                            break;
-            case kBack:    if (Setup.DelTimeshiftRec) { 
+            case kBack:    if (Setup.DelTimeshiftRec) {
                               cRecordControl* rc = cRecordControls::GetRecordControl(fileName);
                               return rc && rc->InstantId() ? osEnd : osRecordings;
                               }
diff -ruN vdr-1.7.37/menuitems.c vdr-1.7.38/menuitems.c
--- vdr-1.7.37/menuitems.c	2012-12-23 14:44:05.000000000 +0100
+++ vdr-1.7.38/menuitems.c	2013-02-15 15:20:29.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 2.15 2012/12/23 13:44:05 kls Exp $
+ * $Id: menuitems.c 2.16 2013/02/15 14:20:29 kls Exp $
  */
 
 #include "menuitems.h"
@@ -759,7 +759,7 @@
      snprintf(buf, sizeof(buf), "%d %s", *value, channel ? channel->Name() : "");
      SetValue(buf);
      if (channelID)
-        *channelID = channel->GetChannelID().ToString();
+        *channelID = channel ? channel->GetChannelID().ToString() : "";
      }
   else if (noneString) {
      SetValue(noneString);
diff -ruN vdr-1.7.37/osd.c vdr-1.7.38/osd.c
--- vdr-1.7.37/osd.c	2013-02-08 11:16:47.000000000 +0100
+++ vdr-1.7.38/osd.c	2013-02-14 16:50:19.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.35 2013/02/08 10:16:47 kls Exp $
+ * $Id: osd.c 2.38 2013/02/14 15:50:19 kls Exp $
  */
 
 #include "osd.h"
@@ -1699,7 +1699,7 @@
 
 void cOsd::DestroyPixmap(cPixmap *Pixmap)
 {
-  if (isTrueColor) {
+  if (Pixmap) {
      LOCK_PIXMAPS;
      for (int i = 1; i < pixmaps.Size(); i++) { // begin at 1 - don't let the background pixmap be destroyed!
          if (pixmaps[i] == Pixmap) {
@@ -1803,6 +1803,10 @@
   if (Result == oeOk) {
      while (numBitmaps)
            delete bitmaps[--numBitmaps];
+     for (int i = 0; i < pixmaps.Size(); i++) {
+         delete pixmaps[i];
+         pixmaps[i] = NULL;
+         }
      width = height = 0;
      isTrueColor = NumAreas == 1 && Areas[0].bpp == 32;
      if (isTrueColor) {
@@ -2053,7 +2057,7 @@
 {
   if (osdProvider)
      return osdProvider->StoreImageData(Image);
-  return -1;
+  return 0;
 }
 
 void cOsdProvider::DropImage(int ImageHandle)
diff -ruN vdr-1.7.37/osd.h vdr-1.7.38/osd.h
--- vdr-1.7.37/osd.h	2013-02-08 10:47:56.000000000 +0100
+++ vdr-1.7.38/osd.h	2013-02-12 14:39:08.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 2.19 2013/02/08 09:47:56 kls Exp $
+ * $Id: osd.h 2.20 2013/02/12 13:39:08 kls Exp $
  */
 
 #ifndef __OSD_H
@@ -253,7 +253,7 @@
        ///< 0       draws the entire ellipse
        ///< 1..4    draws only the first, second, third or fourth quadrant, respectively
        ///< 5..8    draws the right, top, left or bottom half, respectively
-       ///< -1..-8  draws the inverted part of the given quadrant(s)
+       ///< -1..-4  draws the inverted part of the given quadrant
        ///< If Quadrants is not 0, the coordinates are those of the actual area, not
        ///< the full circle!
   void DrawSlope(int x1, int y1, int x2, int y2, tColor Color, int Type);
@@ -624,7 +624,7 @@
        ///< 0       draws the entire ellipse
        ///< 1..4    draws only the first, second, third or fourth quadrant, respectively
        ///< 5..8    draws the right, top, left or bottom half, respectively
-       ///< -1..-8  draws the inverted part of the given quadrant(s)
+       ///< -1..-4  draws the inverted part of the given quadrant
        ///< If Quadrants is not 0, the coordinates are those of the actual area, not
        ///< the full circle!
   virtual void DrawSlope(const cRect &Rect, tColor Color, int Type) = 0;
@@ -897,7 +897,7 @@
        ///< 0       draws the entire ellipse
        ///< 1..4    draws only the first, second, third or fourth quadrant, respectively
        ///< 5..8    draws the right, top, left or bottom half, respectively
-       ///< -1..-8  draws the inverted part of the given quadrant(s)
+       ///< -1..-4  draws the inverted part of the given quadrant
        ///< If Quadrants is not 0, the coordinates are those of the actual area, not
        ///< the full circle!
   virtual void DrawSlope(int x1, int y1, int x2, int y2, tColor Color, int Type);
